Txing

欢迎来到 | 伽蓝之堂

0%

Q26 Remove Duplicates from Sorted Array

Remove Duplicates from Sorted Array

Question

Given a sorted array nums, remove the duplicates in-place such that each element appear only once and return the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

Example 1:

Given nums = [1,1,2],

Your function should return length = 2, with the first two elements of nums being 1 and 2 respectively.

It doesn't matter what you leave beyond the returned length.

Example 2:

Given nums = [0,0,1,1,1,2,2,3,3,4],

Your function should return length = 5, with the first five elements of nums being modified to 0, 1, 2, 3, and 4 respectively.

It doesn't matter what values are set beyond the returned length.

Clarification:

Confused why the returned value is an integer but your answer is an array?

Note that the input array is passed in by reference, which means modification to the input array will be known to the caller as well.

Internally you can think of this:

1
2
3
4
5
6
7
8
>// nums is passed in by reference. (i.e., without making a copy)
>int len = removeDuplicates(nums);

>// any modification to nums in your function would be known by the caller.
>// using the length returned by your function, it prints the first len elements.
>for (int i = 0; i < len; i++) {
print(nums[i]);
>}

Solution

Approach 1: Two Pointers

Since the array is already sorted, we can keep two pointers and , where is the slow-runner while is the fast-runner. As long as , we increment to skip the duplicate.

When we encounter , the duplicate run has ended so we must copy its value to . is then incremented and we repeat the same process again reaches the end of array.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
class Solution:
def removeDuplicates(self, nums: 'List[int]') -> 'int':
if len(nums)==0:
return 0
else:
index=0
while(index+1<len(nums)):
if nums[index]==nums[index+1]:
nums.remove(nums[index])
else:
index+=1
return len(nums)

if __name__ == "__main__":
nums = [2,2,2,3,4]
answer=Solution()
results=answer.removeDuplicates(nums)
print(results)

  • Time complextiy : O(n). Assume that n is the length of array. Each of ii and j traverses at most nnsteps.
  • Space complexity : O(1).

代码中使用了nums.remove() 来删除重复元素,.pop() 也有类似效果,但在提交LeetCode时候超时未通过。